<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"><title>Building nginx from Sources</title><style type="text/css">body { background: white; color: black; font-family: sans-serif; line-height: 1.4em; text-align: center; margin: 0; padding: 0; } #banner { background: black; color: #F2F2F2; line-height: 1.2em; padding: .3em 0; box-shadow: 0 5px 10px black; } #banner a { color: #00B140; } #main { text-align: left; margin: 0 auto; min-width: 32em; max-width: 64em; } #menu { float: right; width: 11em; padding: 0 .5em 1em .5em; border-left: 2px solid #DDD; } #content { margin-right: 13.5em; padding: 0 .2em 0 1.5em; } h1 { display: block; font-size: 3em; text-align: left; height: .7em; margin: 0; margin-bottom: .5em; } h1 img { width: 100%; } h2 { text-align: center; } p { text-align: justify; } table.news p { margin-top: 0; } table.news td { vertical-align: baseline; } table.news .date { text-align: right; padding-right: 0.5em; white-space: nowrap; } table.donors td { vertical-align: baseline; } table.donors li { text-align: left; } div.directive { background: #F2F2F2; line-height: 1em; margin: 1em 0 1em -1em; padding: .7em .7em .7em 1em; border-top: 2px solid #DDD; } div.directive th { padding-left: 0; padding-right: .5em; vertical-align: baseline; text-align: left; font-weight: normal; } div.directive td { vertical-align: baseline; } div.directive pre { padding: 0; margin: 0; } div.directive p { margin: .5em 0 0 .1em; font-size: .8em; } a.notrans { color: gray; text-decoration:none; } span.initial { font-size: 200%; float: left; padding-right: 10pt;} ul, ol { margin: .5em 0 1em 1em; padding: 0 .5em; } ol { list-style-position: inside; } li { text-align: justify; padding: .5em 0 0 1px; } .compact li { padding-top: 0; } dl { margin: .5em 0 1em 0; } dt { margin: .5em 0; } .compact dt { margin-bottom: .2em; } dd { margin-left: 1.5em; padding-left: 1px; text-align: justify; } td.list { background: #F2F2F2; } blockquote { margin: 1em 0 1em 1em; padding: .5em; } li blockquote, dd blockquote { margin: .7em 0; } blockquote.note { border: 1px dotted #999; line-height: 1.2em; text-align: justify; } blockquote.example { line-height: 1em; border-left: 1px solid #BBB; } blockquote.example pre { padding: 0; margin: 0; } sup { font-size: 50%; } .video { position: relative; padding-bottom: 56.25%; overflow: hidden; } .video iframe, .video object, .video embed { position: absolute; top:0; left:0; width:100%; height:100%; }</style><script>
        (function(w, d, s, l, i) {
            w[l] = w[l] || [];
            w[l].push({
                'gtm.start': new Date().getTime(),
                event: 'gtm.js'
            });
            var f = d.getElementsByTagName(s)[0],
                j = d.createElement(s),
                dl = l != 'dataLayer' ? '&l=' + l : '';
            j.async = true;
            j.src = '//www.googletagmanager.com/gtm.js?id=' + i + dl;
            f.parentNode.insertBefore(j, f);
        })(window, document, 'script', 'dataLayer', 'GTM-TPSP33');
    </script></head><body><div id="banner">
        Registration is now open for the free Microservices March Kubernetes event.<br><a href="https://www.nginx.com/c/microservices-march-2022-kubernetes-networking/">Click here</a> to enroll.
    </div><div id="main"><div id="menu"><h1><a href="/"><img src="/nginx.png" alt="nginx"></a></h1><div>english<br><a href="../../ru/docs/configure.html">русский</a><br><br><a href="../../">news</a><br><a href="../../en/">about</a><br><a href="../../en/download.html">download</a><br><a href="../../en/security_advisories.html">security</a><br><a href="./">documentation</a><br><a href="faq.html">faq</a><br><a href="../../en/books.html">books</a><br><a href="../../en/support.html">support</a><br><br><a href="http://trac.nginx.org/nginx">trac</a><br><a href="http://twitter.com/nginxorg">twitter</a><br><a href="https://www.nginx.com/blog/">blog</a><br><br><a href="https://unit.nginx.org/">unit</a><br><a href="njs/">njs</a><br></div></div><div id="content"><h2>Building nginx from Sources</h2><p>
The build is configured using the <code>configure</code> command.
It defines various aspects of the system, including the methods nginx
is allowed to use for connection processing.
At the end it creates a <code>Makefile</code>.
</p><p>
The <code>configure</code> command supports the following parameters:
</p><p>
</p> <dl class="compact">

<dt>
<code>--help</code>
</dt>
<dd>
prints a help message.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--prefix=<code><i>path</i></code></code>
</dt>
<dd>
defines a directory that will keep server files.
This same directory will also be used for all relative paths set by
<code>configure</code> (except for paths to libraries sources)
and in the <code>nginx.conf</code> configuration file.
It is set to the <code>/usr/local/nginx</code> directory by default.
</dd>

<dt>
<code>--sbin-path=<code><i>path</i></code></code>
</dt>
<dd>
sets the name of an nginx executable file.
This name is used only during installation.
By default the file is named
<code><code><i>prefix</i></code>/sbin/nginx</code>.
</dd>

<dt>
<code>--modules-path=<code><i>path</i></code></code>
</dt>
<dd>
defines a directory where nginx dynamic modules will be installed.
By default the <code><code><i>prefix</i></code>/modules</code> directory is used.
</dd>

<dt>
<code>--conf-path=<code><i>path</i></code></code>
</dt>
<dd>
sets the name of an <code>nginx.conf</code> configuration file.
If needs be, nginx can always be started with a different configuration file,
by specifying it in the command-line parameter
<nobr><code>-c <code><i>file</i></code></code></nobr>.
By default the file is named
<code><code><i>prefix</i></code>/conf/nginx.conf</code>.
</dd>

<dt>
<code>--error-log-path=<code><i>path</i></code></code>
</dt>
<dd>
sets the name of the primary error, warnings, and diagnostic file.
After installation, the file name can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="ngx_core_module.html#error_log">error_log</a> directive.
By default the file is named
<code><code><i>prefix</i></code>/logs/error.log</code>.
</dd>

<dt>
<code>--pid-path=<code><i>path</i></code></code>
</dt>
<dd>
sets the name of an <code>nginx.pid</code> file
that will store the process ID of the main process.
After installation, the file name can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="ngx_core_module.html#pid">pid</a> directive.
By default the file is named
<code><code><i>prefix</i></code>/logs/nginx.pid</code>.
</dd>

<dt>
<code>--lock-path=<code><i>path</i></code></code>
</dt>
<dd>
sets a prefix for the names of lock files.
After installation, the value can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="ngx_core_module.html#lock_file">lock_file</a> directive.
By default the value is
<code><code><i>prefix</i></code>/logs/nginx.lock</code>.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--user=<code><i>name</i></code></code>
</dt>
<dd>
sets the name of an unprivileged user whose credentials will be used
by worker processes.
After installation, the name can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="ngx_core_module.html#user">user</a> directive.
The default user name is nobody.
</dd>

<dt>
<code>--group=<code><i>name</i></code></code>
</dt>
<dd>
sets the name of a group whose credentials will be used
by worker processes.
After installation, the name can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="ngx_core_module.html#user">user</a> directive.
By default, a group name is set to the name of an unprivileged user.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt id="build">
<code>--build=<code><i>name</i></code></code>
</dt>
<dd>
sets an optional nginx build name.
</dd>

<dt>
<code>--builddir=<code><i>path</i></code></code>
</dt>
<dd>
sets a build directory.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-select_module</code><br>
<code>--without-select_module</code>
</dt>
<dd>
enables or disables building a module that allows the server to work
with the <code>select()</code> method.
This module is built automatically if the platform does not appear
to support more appropriate methods such as kqueue, epoll, or /dev/poll.
</dd>

<dt>
<code>--with-poll_module</code><br>
<code>--without-poll_module</code>
</dt>
<dd>
enables or disables building a module that allows the server to work
with the <code>poll()</code> method.
This module is built automatically if the platform does not appear
to support more appropriate methods such as kqueue, epoll, or /dev/poll.
</dd>

<dt>
<code>--with-threads</code>
</dt>
<dd>
enables the use of
<a href="ngx_core_module.html#thread_pool">thread pools</a>.
</dd>

<dt>
<code>--with-file-aio</code>
</dt>
<dd>
enables the use of
<a href="http/ngx_http_core_module.html#aio">asynchronous file I/O</a>
(AIO) on FreeBSD and Linux.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-http_ssl_module</code>
</dt>
<dd>
enables building a module that adds the
<a href="http/ngx_http_ssl_module.html">HTTPS protocol support</a>
to an HTTP server.
This module is not built by default.
The OpenSSL library is required to build and run this module.
</dd>

<dt>
<code>--with-http_v2_module</code>
</dt>
<dd>
enables building a module that provides support for
<a href="http/ngx_http_v2_module.html">HTTP/2</a>.
This module is not built by default.
</dd>

<dt>
<code>--with-http_realip_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_realip_module.html">ngx_http_realip_module</a>
module that changes the client address to the address
sent in the specified header field.
This module is not built by default.
</dd>

<dt>
<code>--with-http_addition_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_addition_module.html">ngx_http_addition_module</a>
module that adds text before and after a response.
This module is not built by default.
</dd>

<dt>
<code>--with-http_xslt_module</code><br>
<code>--with-http_xslt_module=dynamic</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_xslt_module.html">ngx_http_xslt_module</a>
module that transforms XML responses using one or more XSLT stylesheets.
This module is not built by default.
The <a href="http://xmlsoft.org">libxml2</a> and
<a href="http://xmlsoft.org/XSLT/">libxslt</a> libraries
are required to build and run this module.
</dd>

<dt>
<code>--with-http_image_filter_module</code><br>
<code>--with-http_image_filter_module=dynamic</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_image_filter_module.html">ngx_http_image_filter_module</a>
module that transforms images in JPEG, GIF, PNG, and WebP formats.
This module is not built by default.
</dd>

<dt>
<code>--with-http_geoip_module</code><br>
<code>--with-http_geoip_module=dynamic</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_geoip_module.html">ngx_http_geoip_module</a>
module that creates variables depending on the client IP address
and the precompiled
<a href="http://www.maxmind.com">MaxMind</a> databases.
This module is not built by default.
</dd>

<dt>
<code>--with-http_sub_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_sub_module.html">ngx_http_sub_module</a>
module that modifies a response by replacing one specified string by another.
This module is not built by default.
</dd>

<dt>
<code>--with-http_dav_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_dav_module.html">ngx_http_dav_module</a>
module that provides file management automation via the WebDAV protocol.
This module is not built by default.
</dd>

<dt>
<code>--with-http_flv_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_flv_module.html">ngx_http_flv_module</a>
module that provides pseudo-streaming server-side support
for Flash Video (FLV) files.
This module is not built by default.
</dd>

<dt>
<code>--with-http_mp4_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_mp4_module.html">ngx_http_mp4_module</a>
module that provides pseudo-streaming server-side support
for MP4 files.
This module is not built by default.
</dd>

<dt>
<code>--with-http_gunzip_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_gunzip_module.html">ngx_http_gunzip_module</a>
module that decompresses responses
with “<code>Content-Encoding: gzip</code>”
for clients that do not support “gzip” encoding method.
This module is not built by default.
</dd>

<dt>
<code>--with-http_gzip_static_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_gzip_static_module.html">ngx_http_gzip_static_module</a>
module that enables sending precompressed files
with the “<code>.gz</code>” filename extension instead of regular files.
This module is not built by default.
</dd>

<dt>
<code>--with-http_auth_request_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_auth_request_module.html">ngx_http_auth_request_module</a>
module that implements client authorization
based on the result of a subrequest.
This module is not built by default.
</dd>

<dt>
<code>--with-http_random_index_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_random_index_module.html">ngx_http_random_index_module</a>
module that processes requests
ending with the slash character (‘<code>/</code>’) and picks a random
file in a directory to serve as an index file.
This module is not built by default.
</dd>

<dt>
<code>--with-http_secure_link_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_secure_link_module.html">ngx_http_secure_link_module</a>
module.
This module is not built by default.
</dd>

<dt>
<code>--with-http_degradation_module</code>
</dt>
<dd>
enables building the
<code>ngx_http_degradation_module</code> module.
This module is not built by default.
</dd>

<dt>
<code>--with-http_slice_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_slice_module.html">ngx_http_slice_module</a>
module that splits a request into subrequests,
each returning a certain range of response.
The module provides more effective caching of big responses.
This module is not built by default.
</dd>

<dt>
<code>--with-http_stub_status_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_stub_status_module.html">ngx_http_stub_status_module</a>
module that provides access to basic status information.
This module is not built by default.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--without-http_charset_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_charset_module.html">ngx_http_charset_module</a>
module that adds the specified charset to the
“Content-Type” response header field
and can additionally convert data from one charset to another.
</dd>

<dt>
<code>--without-http_gzip_module</code>
</dt>
<dd>
disables building a module
that <a href="http/ngx_http_gzip_module.html">compresses responses</a>
of an HTTP server.
The zlib library is required to build and run this module.
</dd>

<dt>
<code>--without-http_ssi_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_ssi_module.html">ngx_http_ssi_module</a>
module that processes SSI (Server Side Includes) commands in responses
passing through it.
</dd>

<dt>
<code>--without-http_userid_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_userid_module.html">ngx_http_userid_module</a>
module that sets cookies suitable for client identification.
</dd>

<dt>
<code>--without-http_access_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_access_module.html">ngx_http_access_module</a>
module that allows limiting access to certain client addresses.
</dd>

<dt>
<code>--without-http_auth_basic_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_auth_basic_module.html">ngx_http_auth_basic_module</a>
module that allows limiting access to resources by validating the user name
and password using the “HTTP Basic Authentication” protocol.
</dd>

<dt>
<code>--without-http_mirror_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_mirror_module.html">ngx_http_mirror_module</a>
module that implements mirroring of an original request
by creating background mirror subrequests.
</dd>

<dt>
<code>--without-http_autoindex_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_autoindex_module.html">ngx_http_autoindex_module</a>
module that processes requests
ending with the slash character (‘<code>/</code>’) and produces
a directory listing in case the
<a href="http/ngx_http_index_module.html">ngx_http_index_module</a> module
cannot find an index file.
</dd>

<dt>
<code>--without-http_geo_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_geo_module.html">ngx_http_geo_module</a>
module that creates variables
with values depending on the client IP address.
</dd>

<dt>
<code>--without-http_map_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_map_module.html">ngx_http_map_module</a>
module that creates variables
with values depending on values of other variables.
</dd>

<dt>
<code>--without-http_split_clients_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_split_clients_module.html">ngx_http_split_clients_module</a>
module that creates variables for A/B testing.
</dd>

<dt>
<code>--without-http_referer_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_referer_module.html">ngx_http_referer_module</a>
module that can block access to a site for requests with invalid values
in the “Referer” header field.
</dd>

<dt>
<code>--without-http_rewrite_module</code>
</dt>
<dd>
disables building a module that allows an HTTP server to
<a href="http/ngx_http_rewrite_module.html">redirect requests and change URI
of requests</a>.
The PCRE library is required to build and run this module.
</dd>

<dt>
<code>--without-http_proxy_module</code>
</dt>
<dd>
disables building an HTTP server
<a href="http/ngx_http_proxy_module.html">proxying module</a>.

</dd>

<dt>
<code>--without-http_fastcgi_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_fastcgi_module.html">ngx_http_fastcgi_module</a>
module that passes requests to a FastCGI server.
</dd>

<dt>
<code>--without-http_uwsgi_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_uwsgi_module.html">ngx_http_uwsgi_module</a>
module that passes requests to a uwsgi server.
</dd>

<dt>
<code>--without-http_scgi_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_scgi_module.html">ngx_http_scgi_module</a>
module that passes requests to an SCGI server.
</dd>

<dt>
<code>--without-http_grpc_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_grpc_module.html">ngx_http_grpc_module</a>
module that passes requests to a gRPC server.
</dd>

<dt>
<code>--without-http_memcached_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_memcached_module.html">ngx_http_memcached_module</a>
module that obtains responses from a memcached server.
</dd>

<dt>
<code>--without-http_limit_conn_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_limit_conn_module.html">ngx_http_limit_conn_module</a>
module that limits the number of connections per key, for example,
the number of connections from a single IP address.
</dd>

<dt>
<code>--without-http_limit_req_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_limit_req_module.html">ngx_http_limit_req_module</a>
module that limits the request processing rate per key, for example,
the processing rate of requests coming from a single IP address.
</dd>

<dt>
<code>--without-http_empty_gif_module</code>
</dt>
<dd>
disables building a module that
<a href="http/ngx_http_empty_gif_module.html">emits single-pixel
transparent GIF</a>.
</dd>

<dt>
<code>--without-http_browser_module</code>
</dt>
<dd>
disables building the
<a href="http/ngx_http_browser_module.html">ngx_http_browser_module</a>
module that creates variables whose values depend on the value of the
“User-Agent” request header field.
</dd>

<dt>
<code>--without-http_upstream_hash_module</code>
</dt>
<dd>
disables building a module that implements the
<a href="http/ngx_http_upstream_module.html#hash">hash</a>
load balancing method.
</dd>

<dt>
<code>--without-http_upstream_ip_hash_module</code>
</dt>
<dd>
disables building a module that implements the
<a href="http/ngx_http_upstream_module.html#ip_hash">ip_hash</a>
load balancing method.
</dd>

<dt>
<code>--without-http_upstream_least_conn_module</code>
</dt>
<dd>
disables building a module that implements the
<a href="http/ngx_http_upstream_module.html#least_conn">least_conn</a>
load balancing method.
</dd>

<dt>
<code>--without-http_upstream_random_module</code>
</dt>
<dd>
disables building a module that implements the
<a href="http/ngx_http_upstream_module.html#random">random</a>
load balancing method.
</dd>

<dt>
<code>--without-http_upstream_keepalive_module</code>
</dt>
<dd>
disables building a module that provides
<a href="http/ngx_http_upstream_module.html#keepalive">caching of
connections</a> to upstream servers.
</dd>

<dt>
<code>--without-http_upstream_zone_module</code>
</dt>
<dd>
disables building a module that makes it possible to store run-time state
of an upstream group in a shared memory
<a href="http/ngx_http_upstream_module.html#zone">zone</a>.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-http_perl_module</code><br>
<code>--with-http_perl_module=dynamic</code>
</dt>
<dd>
enables building the
<a href="http/ngx_http_perl_module.html">embedded Perl module</a>.
This module is not built by default.
</dd>

<dt>
<code>--with-perl_modules_path=<code><i>path</i></code></code>
</dt>
<dd>
defines a directory that will keep Perl modules.
</dd>

<dt>
<code>--with-perl=<code><i>path</i></code></code>
</dt>
<dd>
sets the name of the Perl binary.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--http-log-path=<code><i>path</i></code></code>
</dt>
<dd>
sets the name of the primary request log file of the HTTP server.
After installation, the file name can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="http/ngx_http_log_module.html#access_log">access_log</a> directive.
By default the file is named
<code><code><i>prefix</i></code>/logs/access.log</code>.
</dd>

<dt>
<code>--http-client-body-temp-path=<code><i>path</i></code></code>
</dt>
<dd>
defines a directory for storing temporary files
that hold client request bodies.
After installation, the directory can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="http/ngx_http_core_module.html#client_body_temp_path">client_body_temp_path</a>
directive.
By default the directory is named
<code><code><i>prefix</i></code>/client_body_temp</code>.
</dd>

<dt>
<code>--http-proxy-temp-path=<code><i>path</i></code></code>
</dt>
<dd>
defines a directory for storing temporary files
with data received from proxied servers.
After installation, the directory can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="http/ngx_http_proxy_module.html#proxy_temp_path">proxy_temp_path</a>
directive.
By default the directory is named
<code><code><i>prefix</i></code>/proxy_temp</code>.
</dd>

<dt>
<code>--http-fastcgi-temp-path=<code><i>path</i></code></code>
</dt>
<dd>
defines a directory for storing temporary files
with data received from FastCGI servers.
After installation, the directory can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="http/ngx_http_fastcgi_module.html#fastcgi_temp_path">fastcgi_temp_path</a>
directive.
By default the directory is named
<code><code><i>prefix</i></code>/fastcgi_temp</code>.
</dd>

<dt>
<code>--http-uwsgi-temp-path=<code><i>path</i></code></code>
</dt>
<dd>
defines a directory for storing temporary files
with data received from uwsgi servers.
After installation, the directory can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="http/ngx_http_uwsgi_module.html#uwsgi_temp_path">uwsgi_temp_path</a>
directive.
By default the directory is named
<code><code><i>prefix</i></code>/uwsgi_temp</code>.
</dd>

<dt>
<code>--http-scgi-temp-path=<code><i>path</i></code></code>
</dt>
<dd>
defines a directory for storing temporary files
with data received from SCGI servers.
After installation, the directory can always be changed in the
<code>nginx.conf</code> configuration file using the
<a href="http/ngx_http_scgi_module.html#scgi_temp_path">scgi_temp_path</a>
directive.
By default the directory is named
<code><code><i>prefix</i></code>/scgi_temp</code>.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--without-http</code>
</dt>
<dd>
disables the <a href="http/ngx_http_core_module.html">HTTP</a> server.
</dd>

<dt>
<code>--without-http-cache</code>
</dt>
<dd>
disables HTTP cache.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-mail</code><br>
<code>--with-mail=dynamic</code>
</dt>
<dd>
enables POP3/IMAP4/SMTP
<a href="mail/ngx_mail_core_module.html">mail proxy</a> server.
</dd>

<dt>
<code>--with-mail_ssl_module</code>
</dt>
<dd>
enables building a module that adds the
<a href="mail/ngx_mail_ssl_module.html">SSL/TLS protocol support</a>
to the mail proxy server.
This module is not built by default.
The OpenSSL library is required to build and run this module.
</dd>

<dt>
<code>--without-mail_pop3_module</code>
</dt>
<dd>
disables the <a href="mail/ngx_mail_pop3_module.html">POP3</a> protocol
in mail proxy server.
</dd>

<dt>
<code>--without-mail_imap_module</code>
</dt>
<dd>
disables the <a href="mail/ngx_mail_imap_module.html">IMAP</a> protocol
in mail proxy server.
</dd>

<dt>
<code>--without-mail_smtp_module</code>
</dt>
<dd>
disables the <a href="mail/ngx_mail_smtp_module.html">SMTP</a> protocol
in mail proxy server.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-stream</code><br>
<code>--with-stream=dynamic</code>
</dt>
<dd>
enables building the
<a href="stream/ngx_stream_core_module.html">stream module</a>
for generic TCP/UDP proxying and load balancing.
This module is not built by default.
</dd>

<dt>
<code>--with-stream_ssl_module</code>
</dt>
<dd>
enables building a module that adds the
<a href="stream/ngx_stream_ssl_module.html">SSL/TLS protocol support</a>
to the stream module.
This module is not built by default.
The OpenSSL library is required to build and run this module.
</dd>

<dt>
<code>--with-stream_realip_module</code>
</dt>
<dd>
enables building the
<a href="http/ngx_stream_realip_module.html">ngx_stream_realip_module</a>
module that changes the client address to the address
sent in the PROXY protocol header.
This module is not built by default.
</dd>

<dt>
<code>--with-stream_geoip_module</code><br>
<code>--with-stream_geoip_module=dynamic</code>
</dt>
<dd>
enables building the
<a href="stream/ngx_stream_geoip_module.html">ngx_stream_geoip_module</a>
module that creates variables depending on the client IP address
and the precompiled
<a href="http://www.maxmind.com">MaxMind</a> databases.
This module is not built by default.
</dd>

<dt>
<code>--with-stream_ssl_preread_module</code>
</dt>
<dd>
enables building the
<a href="stream/ngx_stream_ssl_preread_module.html">ngx_stream_ssl_preread_module</a>
module that allows extracting information from the
<a href="https://datatracker.ietf.org/doc/html/rfc5246#section-7.4.1.2">ClientHello</a>
message without terminating SSL/TLS.
This module is not built by default.
</dd>

<dt>
<code>--without-stream_limit_conn_module</code>
</dt>
<dd>
disables building the
<a href="stream/ngx_stream_limit_conn_module.html">ngx_stream_limit_conn_module</a>
module that limits the number of connections per key, for example,
the number of connections from a single IP address.
</dd>

<dt>
<code>--without-stream_access_module</code>
</dt>
<dd>
disables building the
<a href="stream/ngx_stream_access_module.html">ngx_stream_access_module</a>
module that allows limiting access to certain client addresses.
</dd>

<dt>
<code>--without-stream_geo_module</code>
</dt>
<dd>
disables building the
<a href="stream/ngx_stream_geo_module.html">ngx_stream_geo_module</a>
module that creates variables
with values depending on the client IP address.
</dd>

<dt>
<code>--without-stream_map_module</code>
</dt>
<dd>
disables building the
<a href="stream/ngx_stream_map_module.html">ngx_stream_map_module</a>
module that creates variables
with values depending on values of other variables.
</dd>

<dt>
<code>--without-stream_split_clients_module</code>
</dt>
<dd>
disables building the
<a href="stream/ngx_stream_split_clients_module.html">ngx_stream_split_clients_module</a>
module that creates variables for A/B testing.
</dd>

<dt>
<code>--without-stream_return_module</code>
</dt>
<dd>
disables building the
<a href="stream/ngx_stream_return_module.html">ngx_stream_return_module</a>
module that sends some specified value to the client
and then closes the connection.
</dd>

<dt>
<code>--without-stream_set_module</code>
</dt>
<dd>
disables building the
<a href="stream/ngx_stream_set_module.html">ngx_stream_set_module</a>
module that sets a value for a variable.
</dd>

<dt>
<code>--without-stream_upstream_hash_module</code>
</dt>
<dd>
disables building a module that implements the
<a href="stream/ngx_stream_upstream_module.html#hash">hash</a>
load balancing method.
</dd>

<dt>
<code>--without-stream_upstream_least_conn_module</code>
</dt>
<dd>
disables building a module that implements the
<a href="stream/ngx_stream_upstream_module.html#least_conn">least_conn</a>
load balancing method.
</dd>

<dt>
<code>--without-stream_upstream_random_module</code>
</dt>
<dd>
disables building a module that implements the
<a href="stream/ngx_stream_upstream_module.html#random">random</a>
load balancing method.
</dd>

<dt>
<code>--without-stream_upstream_zone_module</code>
</dt>
<dd>
disables building a module that makes it possible to store run-time state
of an upstream group in a shared memory
<a href="stream/ngx_stream_upstream_module.html#zone">zone</a>.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-google_perftools_module</code>
</dt>
<dd>
enables building the
<a href="ngx_google_perftools_module.html">ngx_google_perftools_module</a>
module that enables profiling of nginx worker processes using
<a href="https://github.com/gperftools/gperftools">Google Performance Tools</a>.
The module is intended for nginx developers and is not built by default.
</dd>

<dt>
<code>--with-cpp_test_module</code>
</dt>
<dd>
enables building the
<code>ngx_cpp_test_module</code> module.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--add-module=<code><i>path</i></code></code>
</dt>
<dd>
enables an external module.
</dd>

<dt>
<code>--add-dynamic-module=<code><i>path</i></code></code>
</dt>
<dd>
enables an external dynamic module.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-compat</code>
</dt>
<dd>
enables dynamic modules compatibility.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-cc=<code><i>path</i></code></code>
</dt>
<dd>
sets the name of the C compiler.
</dd>

<dt>
<code>--with-cpp=<code><i>path</i></code></code>
</dt>
<dd>
sets the name of the C preprocessor.
</dd>

<dt>
<code>--with-cc-opt=<code><i>parameters</i></code></code>
</dt>
<dd>
sets additional parameters that will be added to the CFLAGS variable.
When using the system PCRE library under FreeBSD,
<code>--with-cc-opt="-I /usr/local/include"</code>
should be specified.
If the number of files supported by <code>select()</code> needs to be
increased it can also be specified here such as this:
<code>--with-cc-opt="-D FD_SETSIZE=2048"</code>.
</dd>

<dt>
<code>--with-ld-opt=<code><i>parameters</i></code></code>
</dt>
<dd>
sets additional parameters that will be used during linking.
When using the system PCRE library under FreeBSD,
<code>--with-ld-opt="-L /usr/local/lib"</code>
should be specified.
</dd>

<dt>
<code>--with-cpu-opt=<code><i>cpu</i></code></code>
</dt>
<dd>
enables building per specified CPU:
<code>pentium</code>, <code>pentiumpro</code>,
<code>pentium3</code>, <code>pentium4</code>,
<code>athlon</code>, <code>opteron</code>,
<code>sparc32</code>, <code>sparc64</code>,
<code>ppc64</code>.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--without-pcre</code>
</dt>
<dd>
disables the usage of the PCRE library.
</dd>

<dt>
<code>--with-pcre</code>
</dt>
<dd>
forces the usage of the PCRE library.
</dd>

<dt>
<code>--with-pcre=<code><i>path</i></code></code>
</dt>
<dd>
sets the path to the sources of the PCRE library.
The library distribution needs to be downloaded from the
<a href="http://www.pcre.org">PCRE</a> site and extracted.
The rest is done by nginx’s <code>./configure</code> and
<code>make</code>.
The library is required for regular expressions support in the
<a href="http/ngx_http_core_module.html#location">location</a> directive
and for the
<a href="http/ngx_http_rewrite_module.html">ngx_http_rewrite_module</a>
module.
</dd>

<dt>
<code>--with-pcre-opt=<code><i>parameters</i></code></code>
</dt>
<dd>
sets additional build options for PCRE.
</dd>

<dt>
<code>--with-pcre-jit</code>
</dt>
<dd>
builds the PCRE library with
“just-in-time compilation” support (1.1.12, the
<a href="ngx_core_module.html#pcre_jit">pcre_jit</a> directive).
</dd>

<dt>
<code>--without-pcre2</code>
</dt>
<dd>
disables use of the PCRE2 library
instead of the original PCRE library (1.21.5).
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-zlib=<code><i>path</i></code></code>
</dt>
<dd>
sets the path to the sources of the zlib library.
The library distribution (version
1.1.3 — 1.2.11) needs to be downloaded from the
<a href="http://zlib.net">zlib</a> site and extracted.
The rest is done by nginx’s <code>./configure</code> and
<code>make</code>.
The library is required for the
<a href="http/ngx_http_gzip_module.html">ngx_http_gzip_module</a> module.
</dd>

<dt>
<code>--with-zlib-opt=<code><i>parameters</i></code></code>
</dt>
<dd>
sets additional build options for zlib.
</dd>

<dt>
<code>--with-zlib-asm=<code><i>cpu</i></code></code>
</dt>
<dd>
enables the use of the zlib assembler sources optimized
for one of the specified CPUs:
<code>pentium</code>, <code>pentiumpro</code>.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-libatomic</code>
</dt>
<dd>
forces the libatomic_ops library usage.
</dd>

<dt>
<code>--with-libatomic=<code><i>path</i></code></code>
</dt>
<dd>
sets the path to the libatomic_ops library sources.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-openssl=<code><i>path</i></code></code>
</dt>
<dd>
sets the path to the OpenSSL library sources.
</dd>

<dt>
<code>--with-openssl-opt=<code><i>parameters</i></code></code>
</dt>
<dd>
sets additional build options for OpenSSL.
</dd>

</dl><p> 
</p><p>
</p> <dl class="compact">

<dt>
<code>--with-debug</code>
</dt>
<dd>
enables the <a href="debugging_log.html">debugging log</a>.
</dd>

</dl><p> 
</p><p>
Example of parameters usage (all of this needs to be typed in one line):
</p> <blockquote class="example"><pre>
./configure
    --sbin-path=/usr/local/nginx/nginx
    --conf-path=/usr/local/nginx/nginx.conf
    --pid-path=/usr/local/nginx/nginx.pid
    --with-http_ssl_module
    --with-pcre=../pcre2-10.39
    --with-zlib=../zlib-1.2.11
</pre></blockquote><p> 
</p><p>
After configuration,
nginx is compiled and installed using <code>make</code>.
</p></div></div></body></html>
